// **********************************************************************
//
// Copyright (c) 2003-2011 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.4.2
//
// <auto-generated>
//
// Generated from file `BuiltinSequences.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

#ifndef ICE_API_EXPORTS
#   define ICE_API_EXPORTS
#endif
#include <Ice/BuiltinSequences.h>
#include <Ice/BasicStream.h>
#include <Ice/Object.h>
#include <Ice/LocalException.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/DisableWarnings.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 304
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 2
#       error Ice patch level mismatch!
#   endif
#endif

void
Ice::__writeObjectSeq(::IceInternal::BasicStream* __os, const ::Ice::ObjectPtr* begin, const ::Ice::ObjectPtr* end)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        __os->write(begin[i]);
    }
}

void
Ice::__readObjectSeq(::IceInternal::BasicStream* __is, ::Ice::ObjectSeq& v)
{
    ::Ice::Int sz;
    __is->readAndCheckSeqSize(4, sz);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        __is->read(::Ice::__patch__ObjectPtr, &v[i]);
    }
}

// COMPILERFIX: Stream API is not supported with VC++ 6
#if !defined(_MSC_VER) || (_MSC_VER >= 1300)
void
Ice::ice_writeObjectSeq(const ::Ice::OutputStreamPtr& __outS, const ::Ice::ObjectSeq& v)
{
    __outS->writeSize(::Ice::Int(v.size()));
    ::Ice::ObjectSeq::const_iterator p;
    for(p = v.begin(); p != v.end(); ++p)
    {
        __outS->write((*p));
    }
}

void
Ice::ice_readObjectSeq(const ::Ice::InputStreamPtr& __inS, ::Ice::ObjectSeq& v)
{
    ::Ice::Int sz = __inS->readAndCheckSeqSize(4);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        __inS->read(v[i]);
    }
}
#endif

void
Ice::__writeObjectProxySeq(::IceInternal::BasicStream* __os, const ::Ice::ObjectPrx* begin, const ::Ice::ObjectPrx* end)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        __os->write(begin[i]);
    }
}

void
Ice::__readObjectProxySeq(::IceInternal::BasicStream* __is, ::Ice::ObjectProxySeq& v)
{
    ::Ice::Int sz;
    __is->readAndCheckSeqSize(2, sz);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        __is->read(v[i]);
    }
}

// COMPILERFIX: Stream API is not supported with VC++ 6
#if !defined(_MSC_VER) || (_MSC_VER >= 1300)
void
Ice::ice_writeObjectProxySeq(const ::Ice::OutputStreamPtr& __outS, const ::Ice::ObjectProxySeq& v)
{
    __outS->writeSize(::Ice::Int(v.size()));
    ::Ice::ObjectProxySeq::const_iterator p;
    for(p = v.begin(); p != v.end(); ++p)
    {
        __outS->write((*p));
    }
}

void
Ice::ice_readObjectProxySeq(const ::Ice::InputStreamPtr& __inS, ::Ice::ObjectProxySeq& v)
{
    ::Ice::Int sz = __inS->readAndCheckSeqSize(2);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        __inS->read(v[i]);
    }
}
#endif
